-module(spec).

-abstype spec() = spec().

-abstype fspec() = fspec().

-abstype env() = env().

-abstype typedef() = typedef().

- abstype tag() = t.

- abstype attribute() = t.

spec_type(spec()) ->
    var + alias + funspec + mfunspec + clause + functor + 'fun' + 
	pid + 
	union + universal + empty + apply + external + special + dict +
	module_attribute + function_attribute.



typedef_arity(typedef()) ->
    int().

funspec_name(spec()) ->
    atom().

funspec_arity(spec()) ->
    int().

mfunspec_name(spec()) ->
    atom().

mfunspec_arity(spec()) ->
    int().

special_name(spec()) ->
    atom().

special_arity(spec()) ->
    int().

attribute_tag(spec()) ->
    tag().

attribute_value(spec()) ->
    spec().

function_attribute_name_arity(spec()) ->
    {atom(), int()}.
