-module(tag).

-type term() = term:term().
-type context() = context:context().
-type pos() = int().
-type list(X) = [X|list(X)] + [].

-public_type ip_name() = any().

self(context()) ->
    term().

result(context()) ->
    term().

except(context()) ->
    term().

arg(int(), context()) ->
    term().

receive_result(pos(), context()) ->
    term().

vector(context(), int(), int()) ->
    list(term()).

var(atom(), pos(), context()) ->
    term().

try_except(pos(), context()) ->
    term().

spawn_mbox(pos(), context()) ->
    term().

pid_dict(pos(), context()) ->
    term().

try_body_result(pos(), context()) ->
    term().

apply_result(pos(), context()) ->
    term().

call_result(pos(), context()) ->
    term().

% invent_fun_arg_list(int(), context(), int()) ->
%     list(term()).

fun_arg(context(), int(), pos()) ->
    term().

fun_result(context(), pos()) ->
    term().

any_string() ->
    term().

interesting(ip_name()) ->
    true + false.
