-module(walker).

- type fnid() = program:fnid().

-public_type env() = env:env(kinds:core_node() + atom(),
			     term:term()).

-type list(X) = [X | list(X)] + [].

+ dict = (current_fnid -> fnid()).

definition(kinds:core_node(), context:context(), as:state()) ->
    as:state().

exp(kinds:core_node(), env(),  context:context(), as:state()) ->
    {term:term(), as:state()}.

exp_list(list(kinds:core_node()), env(),  context:context(), as:state()) ->
    {list(term:term()), as:state()}.

apply_exp(kinds:core_node(), env(), context:context(), as:state()) ->
    {term:term(), as:state()}.

set_current_fnid(fnid()) ->
    true.

current_fnid() ->
    fnid().


		 
