-module(work).

-abstype work() = {work_selection(), context()}.

-type context() = context:context().

-type pos() = term:pos().

-type work_selection() = top_level + analysis + specification
                + generation + matching.

-abstype index() = {work_selection(), program:fnid(), int()}.


iter(as:state()) ->
    as:state().

work(work(), as:state()) ->
    as:state().

current_work() ->
    work().

set_current_work(work()) ->
    work() + undefined.

call_top_level(program:fnid(), pos(), context:context(), as:state()) ->
    {context:context(), as:state()}.

call_analysis(program:fnid(), pos(), context:context(), as:state()) ->
    {context:context(), as:state()}.

call_matching(program:fnid(), pos(), context:context(), as:state()) ->
    {context:context(), as:state()}.

call_generation(program:fnid(), pos(), context:context(), as:state()) ->
    {context:context(), as:state()}.

call_specification(program:fnid(), pos(), context:context(), as:state()) ->
    {context:context(), as:state()}.

work_index(work()) ->
    index().

% analysis(context()) ->
%     work().

% specification(context()) ->
%     work().

% matching(context()) ->
%     work().

% generation(context()) ->
%     work().

% work_category(work()) ->
%     analysis + specification + generation + matching.
